use crate::challenge_args::ChallengeArgs;

pub fn get_top_calorie(args: &ChallengeArgs) -> Option<u32> {
    calc_calories(split_into_elves(args)).max()
}

pub fn get_total_cal_top(args: &ChallengeArgs) -> Option<u32> {
    let mut ranking: Vec<u32> = calc_calories(split_into_elves(args)).collect();
    ranking.sort();
    ranking.reverse();
    Some(ranking.into_iter().take(3).sum())
}

fn split_into_elves(args: &ChallengeArgs) -> std::str::Split<&str> {
    args.input.trim().split("\n\n")
}

fn calc_calories<'a>(elves: std::str::Split<'a, &'a str>) -> impl Iterator<Item = u32>+ '_ {
    elves.map(
        |s| {
            s.lines()
            .map(|s| s.parse::<u32>().expect(""))
            .reduce(|a, b| a+b).unwrap()
        })
}