use core::panic;

pub fn calc_score_of_strat(game_nr: u32, input: &str) -> u32 {
    let games = parse(input);
    let calc_game_score = match game_nr {
        1 => calc_game_score_task_1,
        2 => calc_game_score_task_2,
        _ => panic!()
    };
    games.map(|mut game| calc_game_score(game.next().unwrap(), game.next().unwrap())).fold(0u32, |a, b| a + (b as u32))

}

fn parse(input: &str) -> impl Iterator<Item = impl Iterator<Item = &str>>{
    input.trim().split('\n').map(|s| s.split(' '))
}


fn calc_game_score_task_1<'a>(other: &'a str, me: &'a str) -> u8 {
    let result = match me {
        "X" => match other {
            "A" => 1+3,
            "B" => 1+0,
            "C" => 1+6,
            _ => panic!()
        },
        "Y" => match other {
            "B" => 2+3,
            "C" => 2+0,
            "A" => 2+6,
            _ => panic!()
        }
        "Z" => match other {
            "C" => 3+3,
            "A" => 3+0,
            "B" => 3+6,
            _ => panic!()
        }
        _ => panic!()
    };

    result
}

fn calc_game_score_task_2<'a>(other: &'a str, need: &'a str) -> u8 {
    let result = match other {
        "A" => match need {
            "X" => 3+0,
            "Y" => 1+3,
            "Z" => 2+6,
            _ => panic!()
        },
        "B" => match need {
            "X" => 1+0,
            "Y" => 2+3,
            "Z" => 3+6,
            _ => panic!()
        }
        "C" => match need {
            "X" => 2+0,
            "Y" => 3+3,
            "Z" => 1+6,
            _ => panic!()
        }
        _ => panic!()
    };

    result
}